//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
//------------------------------------------------------------------------------
//
//  Header: S3C2440A_AC97.h
//
//  Defines the AC97 controller CPU register layout and definitions.
//
#ifndef __S3C2440A_AC97_H
#define __S3C2440A_AC97_H

#if __cplusplus
    extern "C" 
    {
#endif

//------------------------------------------------------------------------------
//  Type: S3C2440A_AC97_REG    
//
//  AC97 control registers. This register bank is located by the constant
//  CPU_BASE_REG_XX_AC97 in the configuration file cpu_base_reg_cfg.h.
//

typedef struct {
	unsigned int AC_GLBCTRL;		// 0x00
	unsigned int AC_GLBSTAT;		// 0x04
	unsigned int AC_CODEC_CMD;		// 0x08
	unsigned int AC_CODEC_STAT;		// 0x0c
	unsigned int AC_PCMADDR;		// 0x10
	unsigned int AC_MICADDR;		// 0x14
	unsigned int AC_PCMDATA;		// 0x18
	unsigned int AC_MICDATA;		// 0x1c

} S3C2440A_AC97_REG, *PS3C2440A_AC97_REG;

#if __cplusplus
    }
#endif

#endif 
